import random
import sys
import os
import csv

# A function for getting the data from a specific ranking
def ranking(FILE):
    
    def read_file(text):
        with open(text, 'r') as f:
            data = [row for row in csv.reader(f.read().splitlines())]
        return data

    with open('created_data/'+str(FILE), 'rU') as h:
        data = []
        data2 = []
        i= 0
        reader = csv.reader(h,delimiter=",")
        for row in reader:
            data.append([float(x) for x in row])
            row2 = sorted([float(x) for x in row])
            data2.append([row2.index(v)+1 for v in [float(x) for x in row]])
    return data2 

#create an array of the different potential rankings for the specific source data
def array(group):
    import itertools
    group = [group[i]*2 for i in range(0,len(group))]
    ll = []
    listOLists = [[i for i in range(1,group[t]+1)] for t in range(0,len(group))]
    ll = list(itertools.product(*listOLists))
    for i in range(0,len(ll)):
        ll[i] = list(ll[i])
    return ll

#Create a sorted list of four random numbers that sum to 1	
def SMAA_sorted():
    #n is the number of random values
    n = 4
    a = [random.random() for i in range(0,n-1)]
    a.sort()
    a = [0]+a+[1]
    c = [round(a[i]-a[i-1],6) for i in range(1,len(a))]
    m1 = max(c)
    c.remove(m1)
    m2 = max(c)
    c.remove(m2)
    m3 = max(c)
    c.remove(m3)
    m4 = max(c)
    c.remove(m4)
    c = [m1,m3,m4,m2]
    return c

#Create a list of four random numbers that sum to 1	
def SMAA_unsorted():
    #n is the number of random values
    n = 4
    a = [random.random() for i in range(0,n-1)]
    a.sort()
    a = [0]+a+[1]
    c = [round(a[i]-a[i-1],6) for i in range(1,len(a))]
    return c

#Create a list of partially random numbers, with the last value in the list being 0.5
def SMAA_W1gt5():
    #n is the number of random values
    n = 4
    a = [random.random() for i in range(0,n-1)]
    a.sort()
    a = [0]+a+[1]
    c = [round((a[i]-a[i-1])/2,6) for i in range(1,len(a))]
    c[0] = round(c[0]+0.5,6)
    return c

#Main function to create data for primary model
def main():
    #get data for the individual groups
    h = open('data/ind_groups.txt', 'r')
    ind_groups = h.read()
    h.close()
    ind_groups = [int(ind_groups.split(",")[i]) for i in range(0,len(ind_groups.split(",")))]
    
	#get data for the consenus groups
    h = open('data/cons_groups.txt', 'r')
    cons_groups = h.read()
    h.close()
    cons_groups = [int(cons_groups.split(",")[i]) for i in range(0,len(cons_groups.split(",")))]
    
	#get ranking data for the different metrics
    ind_inf = ranking("Ranking_values_ind_Lpinf.txt")
    ind_1 = ranking("Ranking_values_ind_Lp1.txt")
    cons_inf = ranking("Ranking_values_cons_Lpinf.txt")
    cons_1 = ranking("Ranking_values_cons_Lp1.txt")

	#Create the data file.
    i = open('created_data/Stoch_Preferences_data.dat', 'w')
    i.write("RIJ_IND = [")
    k1,k2 = 0,0
    for ii in range(0,4):
        i.write("[")
        for j in range(0,ind_groups[ii]):
            i.write(str(str(ind_inf[k1])+",\r"))
            if j == ind_groups[ii]-1:
                i.write(str(str(ind_1[k1])+"\r"))
            else:
                i.write(str(str(ind_1[k1])+",\r"))
            k1 = k1+1
        i.write("]")
    i.write("];\r\r")    
    
    i.write("RIJ_CONS = [")
    for ii in range(0,4):
        i.write("[")
        for j in range(0,cons_groups[ii]):
            i.write(str(str(cons_inf[k2])+",\r"))
            if j == cons_groups[ii]-1:
                i.write(str(str(cons_1[k2])+"\r"))
            else:
                i.write(str(str(cons_1[k2])+",\r"))
            k2 = k2+1
        i.write("]")
    i.write("];\r\r")                
    

    i.write("Array_CONS = ")
    i.write(str(array(cons_groups)))
    i.write(";\r\r")

    i.write("Array_IND = ")
    i.write(str(array(ind_groups)))
    i.write(";\r\r")
    #Create a list of weights (first 3 cases have 1000 weights, while last has certain weights).
    i.write("Wt1 =[")
    for j in range(0,1000):
        i.write(str(SMAA_unsorted()))
        if j != 1000-1:
            i.write(",")
    i.write("];\rWt2 = [")
    for j in range(0,1000):
        i.write(str(SMAA_sorted()))
        if j != 1000-1:
            i.write(",")
    i.write("];\rWt3 = [")
    for j in range(0,1000):
        i.write(str(SMAA_W1gt5()))
        if j != 1000-1:
            i.write(",")
    i.write("];\r")
    i.write("Wt4 =[0.504,0.170,0.085,0.242];\r")	
    i.close()

main()
